module alice
open bytes
open crypto_interface
open assumptions

(* -------------- Alice Interface -------------- *)
val Alice: eq bytes -> ca:cipher{| (FromAboth (L ca) (R ca)) 
								&& ( exists (mLa:bytes) (mRa:bytes).( 
											(Encryptedboth mLa mRa (L ca) (R ca)) 
											&& (Marshboth (L v1) (R v2) mLa mRa) ) 
								) |}							
(* -------------- Alice Implementation -------------- *)
let Alice arg = 
	let v1Byt = I2B v1 in
	let v2Byt = I2B v2 in
	let va = choice v1Byt v2Byt in
	let ca = encA_in_progress va in
	ca	
	
(* -------------- Trash -------------- *)
(* COMMENT: Does not work for unknown reasons. Should work normally.
val Alice: eq bytes -> ca:cipher{| (FromAboth (L ca) (R ca)) 
								&& ( exists (mLa:bytes) (mRa:bytes) (zLa:int) (zRa:int).( 
											(zLa = L v1) && (zRa = R v2) &&
											(Encryptedboth mLa mRa (L ca) (R ca)) 
											&& (Marshboth zLa zRa mLa mRa) ) 
								) |}
*)
