module ballot_box
open bytes
open crypto_interface
open assumptions

(* -------------- Ballot Box Interface -------------- *)
val BallotBox: ca:cipher{| (FromAboth (L ca) (R ca)) 
								&& ( exists (mLa:bytes) (mRa:bytes).( 
											(Encryptedboth mLa mRa (L ca) (R ca)) 
											&& (Marshboth (L v1) (R v2) mLa mRa) ) 
								) |} 
		-> cb:cipher{| (FromBboth (L cb) (R cb)) 
								&& ( exists (mLb:bytes) (mRb:bytes).( 
											(Encryptedboth mLb mRb (L cb) (R cb)) 
											&& (Marshboth (L v2) (R v1) mLb mRb) ) 
								) |}
		-> co:cipher
		-> error
		-> result

(* -------------- Ballot Box Implementation -------------- *)				
let BallotBox ca cb co e = 
	let ba = check_val_in_progress ca in
	match ba with
	| false -> e
	| true -> 
	let bb = check_val_in_progress cb in
	match bb with
	| false -> e
	| true ->
	let bo = check_val_in_progress co in
	(* Note: If the intruder send an homo encryption of ca and ca then, bo = false and protocol still typechecks *)
	match bo with
	| false -> e
	| true ->
	if (co = ca) then e else
	if (co = cb) then e else
	let cab = homo_in_progress ca cb in
	let cfinal = homo_in_progress cab co in
	let mfinal = dec_in_progress cfinal in
	mfinal	
	
(* -------------- Trash -------------- *)
