module ballot_box_interface
open bytes
open crypto_interface
open assumptions

(* -------------- Ballot Box Interface -------------- *)
val BallotBox: ca:cipher{| (FromAboth (L ca) (R ca)) 
								&& ( exists (mLa:bytes) (mRa:bytes).( 
											(Encryptedboth mLa mRa (L ca) (R ca)) 
											&& (Marshboth (L v1) (R v2) mLa mRa) ) 
								) |} 
		-> cb:cipher{| (FromBboth (L cb) (R cb)) 
								&& ( exists (mLb:bytes) (mRb:bytes).( 
											(Encryptedboth mLb mRb (L cb) (R cb)) 
											&& (Marshboth (L v2) (R v1) mLb mRb) ) 
								) |}
		-> co:cipher
		-> error
		-> result
		
(* -------------- Trash -------------- *)
(* COMMENT: previous interface without marshalling. *)
(*
val BallotBox: ca:cipher{| (FromAboth (L ca) (R ca)) 
				&& ( exists (mLa:int) (mRa:int).( (Encryptedboth mLa mRa (L ca) (R ca)) 
												&& (mLa = L v1) && (mRa = R v2) ) 
				) |} 
		-> cb:cipher{| (FromBboth (L cb) (R cb)) 
				&& ( exists (mLb:int) (mRb:int).( (Encryptedboth mLb mRb (L cb) (R cb)) 
												&& (mLb = L v2) && (mRb = R v1) ) 
				) |}
		-> co:cipher
		-> error
		-> result
*)