module protocol
open bytes
open crypto_interface
open assumptions 
open alice_interface
open bob_interface
open ballot_box_interface

(* -------------- Types for the Protocol -------------- *)
(* Note: In the end, the protocol should have type eq bytes -> eq bytes *)
(* Comment: Subtyping seems not working. *)

type in_P1_t = eq bytes
type in_P2_t = eq bytes
type in_P3_t = cipher
type out_P3_t = result
type out_P2_t = ( cipher * (in_P3_t -> out_P3_t) )
type out_P1_t = ( cipher * (in_P2_t -> out_P2_t) )


(* -------------- Protocol ------------- *)

val P1: error -> in_P1_t -> out_P1_t

let P1 e arg1 =

	let cA = Alice arg1 in 

	let P2 arg2 = 
		let cB = Bob arg2 in
			
		let P3 arg3 = 
			let res = BallotBox cA cB arg3 e in	
			res in	
			
		(cB,P3) in
	(cA,P2)

(* -------------- Trash -------------- *)	